<?php
/**
 * Created by PhpStorm.
 * User: 肖保元
 * Date: 2016/4/1
 * Time: 15:56
 */

use Phalcon\Cli\Task;
use JiuYang\Phalcon\Extensions\Factorys\Bizs as BizFactory;
use JiuYang\Phalcon\Extensions\Exceptions\Exception as JiuYangException;
use Phalcon\Mvc\Model\Query\Builder as QueryBuilder;
use JiuYang\Phalcon\Extensions\Factorys\SendType;
use JiuYangPErp\Models\Messages;
use JiuYangPErp\Models\WorkflowAlarms;
use JiuYangPErp\Models\AlarmRule;
use JiuYang\Phalcon\Extensions\Factorys\WarningType;
//发送邮箱类
use JiuYangPerp\Consoles\Workers\Messagers\EmailTmp as emailPluggableUnitTmp;

require_once  __DIR__ . '/'."../websocketClient.php";

class WarningTask extends Task
{
    const NOTIFY_ROLES_ERROR = '201:通知的角色用户不存在!';
    const MESSAGE_ERROR = '202:消息保存失败!';
    const JOBS_FETERROR = '1006:工单查找失败!';

    //设置循环的时间
    const SCAN_INTERVAL = 1800;

    //设置报警轮询时间
    const SCAN_WARNING = 30;
    //const SCAN_WARNING = 5;

    //通知的角色
    const NOTIFY_TO = 'df8bb8f7d1';
    //通知的内容
    const NOTIFY_CONTENT = '编号为{$jobs_code}的采购单延迟了';
    protected static $notice ; //代替
    //记录开始时间延迟的（默认没有）
    private $josStartDelay = false;
    //记录结束时间延迟的 (默认没有)
    private $josEndDelay = false;
    //极光推送类
    protected static  $jpush ;

    /**
     * 流程报警进程
     * @author 肖保元
     * @date 2017/03/21
     * @time 15:04
     */
    public function warningAction()
    {
            while (true) {
                try{
                    //查询所有报警记录
                    $alarms = WorkflowAlarms::find("status='N'");

                    //判断是否有查到结果
                    if ($alarms -> toArray()) {

                        //将结果集转换成数组
                        $alarms = $alarms -> toArray();

                        //遍历结果集
                        foreach ($alarms as $value) {

                            //分流 获取报警类
                            $warningType = WarningType::getInstanceAdapter($value['workflow_code'],$value['condadpter']);
                            //执行报警操作
                            $warningType->handle($value);
                        }

                    }
                    //分流 获取报警类
                    //$warningType = WarningType::getInstanceAdapter($alarms['workflow_code'],$alarms['condadpter']);

                    //执行报警操作
                    //$warningType->handle($value);
                    //$warningType->handle($alarms);

                }catch (JiuYangException $error) {
                    //数字类型：int|mixed
                    $errorCode =  $error->getCode();
                    //字符串类型：string
                    $errorMsg =  $error->getMessage();
                    //字符串类型：string
                    $errorFile = $error->getFile();
                    //数字类型：int
                    $errorLine = $error->getLine();

                    $content = '错误号:'.$errorCode.'；错误消息:'.$errorMsg.'；错误文件:'.$errorFile.'；错误行号:'.$errorLine;

                    $data = array();
                    $data['title'] = 'WarningTask脚本错误消息提醒';
                    $data['content'] = $content;


                    //$email = new emailPluggableUnitTmp();
                    //$res = $email->send($data);

                }

                //报警间隔时间
                sleep(self::SCAN_WARNING);
                //sleep(self::SCAN_INTERVAL);

           }

    }

    /**
     * @return void
     * 发送警告消息
     */
    public function sendWarningAction(){
        while (true) {
            try{
                #获取符合通知的数据
                $biz = new \JiuYangPErp\Bizs\Alarmrule();
                $alarms = $biz->getWarningList();
                //判断是否有查到结果
                if ($alarms) {
                    //遍历结果集
                    foreach ($alarms as $value) {
                        //分流 获取报警类
                        $warningType = WarningType::getInstanceAdapter($value['workflow_code'],$value['condadpter']);
                        //执行报警操作
                        $warningType->handle($value);
                    }
                }
            }catch (JiuYangException $error) {
            }
            //报警间隔时间
            sleep(self::SCAN_WARNING);
        }
    }

   /**
     * @return void
     * 报警规则触发
     */
    public function alarmRuleAction(){
        while(true) {
            try {
                //获取数据库配置
                $pdo = (new MainTask())->getPdo();
                //查询报警规则记录
//                $alarms = AlarmRule::find("status='N'");
                //查询报警规则
                $sql = "select * from alarm_rule where status = 'N'";
                $alarms = $pdo->query($sql)->fetchAll(\Phalcon\Db::FETCH_ASSOC);
                if ($alarms) {
                    foreach ($alarms as $rule) {
                        $process = new \swoole_process(function()use ($rule){
                            try {
                                //实例化报表引擎逻辑类
                                $biz = new \JiuYangPErp\Bizs\Alarmrule();
                                //发送报警
                                $biz ->alarmRule($rule);

                            } catch (\Phalcon\Exception $error) {
                                $errorParams = [
                                    'scenario_name' => 'alarmRule',
                                    'data' => []
                                ];
                                //保存报错日志
                                $this->saveLog(json_encode($errorParams),$error);
                                //print_r($error);die;
                            }
                        },false);
                        //开启子进程 并获取子进程的PID
                        $pid = $process->start();
                        //回收子进程
                        $recovery = $process->wait();
                    }
                }
                sleep(120);
            }  catch (\Phalcon\Exception $error) {
                $errorParams = [
                    'scenario_name' => 'alarmRule',
                    'data' => []
                ];
                //保存报错日志
                $this->saveLog(json_encode($errorParams),$error);
            }
        }
    }


    /**
     * @return void
     * 报警规则触发
     */
    public function alarmRulesAction(){
        while (true) {
            try{
                //查询报警规则记录
                $alarms = AlarmRule::find("status='N'");
                //判断是否有查到结果
                if ($alarms -> toArray()) {
                    //将结果集转换成数组
                    $alarms = $alarms -> toArray();
                    $biz = new \JiuYangPErp\Bizs\Alarmrule();
                    //遍历结果集
                    foreach ($alarms as $value) {
                       //获取是否触发报警阈值
                       $biz ->alarmRule($value);
                    }
                }
            }catch (JiuYangException $error) {
                $errorParams = [
                    'scenario_name' => 'alarmRule',
                    'data' => []
                ];

                //保存报错日志
                $this->saveLog(json_encode($errorParams),$error);
                //print_r($error);die;
            }

            //报警间隔时间
            sleep(self::SCAN_WARNING);
            //sleep(self::SCAN_INTERVAL);
        }
    }


    /**
     * 保存报错日志
     * @date 2023/07/19
     * @param $errorParams
     * @param $error
     */
    public function saveLog($errorParams,$error) {

        //数字类型：int|mixed
        $errorCode =  $error->getCode();
        //字符串类型：string
        $errorMsg =  $error->getMessage();
        //字符串类型：string
        $errorFile = $error->getFile();
        //数字类型：int
        $errorLine = $error->getLine();

        //捕获自定义错误
        $errorBiz = new \JiuYangPerp\Consoles\Workers\Log\QueueLog();
        $errorBiz -> logCatch($errorCode,$errorMsg,$errorFile,$errorLine,$errorParams);

        return false;

    }

    /**
     * iot平台数据采集报错
     * @description 近30分钟内，property类型的云端日志记录为空，则发送钉钉报警信息，接收人为钉钉信息测试岗位的人员
     * @date 2025-03-03
     */
    public function iotAction(){

        while (true) {
            try {

                //开始时间，30分钟前
                $start = (time() - 1800)*1000;

                //结束时间，当前时间
                $end = time() * 1000;

                $biz = new \JiuYangPErp\Bizs\Reportrtdata();

                //查询近30分钟的property类型的日志记录
                $sql = "SELECT count(*) as total FROM iThings.model_common_hublog where  `action` = 'property' and content != '' and ts between {$start} and {$end}  ";

                $result = $biz->iotrest($sql,true);

                //记录条数
                $total = $result['data'][0]['total'];

                //记录为空，进行钉钉报警
                if ($result['code'] === 0 && $result['rows'] === 1 && $total === 0) {

                    //报警接收人为钉钉测试岗人员，查询人员编号
                    $hyper = new \JiuYangPErp\Bizs\Hyper();
                    $hyper->setModel("Positions");
                    $position = $hyper->findFirst("name = '钉钉信息测试岗'")['code'];
                    $hyper->setModel("Users");
                    $users = $hyper->find("positions_code like '%{$position}%' and istoding = 'Y' and length(userid) > 0 and status = 'N'");

                    //进行消息的转入队列
                    $queue = $this->getDI()->get('beanstalkd');

                    if (!$queue->connect()) {
                        throw new JiuYangException("1052:Can't connect beanstalk service", null);
                    }

                    //获取模式配置
                    $config = $this->getDI()->get('cliConfig');

                    //获取beanstalkd使用tube
                    $tube = $config['beanstalkd']['tube'];


                    //声明消息发送次序
                    $i = 0;
                    //声明消息接收者列表长度
                    $length = 0;
                    //声明接收人信息
                    $account = [];

                    foreach ($users as $user) {
                        //接收者的userid列表，最大用户列表长度100。
                        if ($length + strlen($user['userid']) + 1 <= 100) { //接收者的userid列表，最大用户列表长度100。
                            $length = $length + strlen($user['userid']) + 1;

                        } else {

                            //增加次序
                            $i++;
                            //重新计算用户列表长度
                            $length = strlen($user['userid']) + 1;
                        }

                        $account[$i][] = $user['userid'];

                    }


                    //放入钉钉消息发送队列
                    foreach ($account as $key=>$value) {

                        $queueData = [
                            'accountcode' => implode(",",$value),
                            'type' => 'warning',
                            'readType' => 'N',
                            'sendtype' => "Dingding",
                            'title' => 'IOT数据采集错误',
                            'content' => "云端日志不包含属性信息，请核查实际情况！",
                            'sendtime' => time(),
                            'structure' => ''
                        ];

                        $queue->choose($tube);

                        $queue->put($queueData);
                    }


                }

                echo "执行完成！";

            } catch (\Phalcon\Exception $error) {
                $errorParams = [
                    'scenario_name' => 'iot',
                    'data' => []
                ];
                //保存报错日志
                $this->saveLog(json_encode($errorParams),$error);
            }

            //间隔时间30分钟
            sleep(1800);
        }




    }




}
